// Generated by the Tensor Algebra Compiler (tensor-compiler.org)
// /nix/store/k9ygr43gc7gzdk9r6nfz8m7c3fbi6f9x-python3.10-taco-2b8ece4/bin/taco "P(t) = Pi(a) * Ji(a,t)" -f=P:d -f=Pi:d -f=Ji:ds -t=P:double -t=Pi:double -t=Ji:double -write-compute=t_1_1_.c -write-source=t_1_1_.c -prefix=t_1_1_
#ifndef TACO_C_HEADERS
#define TACO_C_HEADERS
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <stdbool.h>
#include <math.h>
#include <complex.h>
#include <string.h>
#if _OPENMP
#include <omp.h>
#endif
#define TACO_MIN(_a,_b) ((_a) < (_b) ? (_a) : (_b))
#define TACO_MAX(_a,_b) ((_a) > (_b) ? (_a) : (_b))
#define TACO_DEREF(_a) (((___context___*)(*__ctx__))->_a)
#ifndef TACO_TENSOR_T_DEFINED
#define TACO_TENSOR_T_DEFINED
typedef enum { taco_mode_dense, taco_mode_sparse } taco_mode_t;
typedef struct {
  int32_t      order;         // tensor order (number of modes)
  int32_t*     dimensions;    // tensor dimensions
  int32_t      csize;         // component size
  int32_t*     mode_ordering; // mode storage ordering
  taco_mode_t* mode_types;    // mode storage types
  uint8_t***   indices;       // tensor index data (per mode)
  uint8_t*     vals;          // tensor values
  uint8_t*     fill_value;    // tensor fill value
  int32_t      vals_size;     // values array size
} taco_tensor_t;
#endif
#if !_OPENMP
int omp_get_thread_num() { return 0; }
int omp_get_max_threads() { return 1; }
#endif
int cmp(const void *a, const void *b) {
  return *((const int*)a) - *((const int*)b);
}
int taco_gallop(int *array, int arrayStart, int arrayEnd, int target) {
  if (array[arrayStart] >= target || arrayStart >= arrayEnd) {
    return arrayStart;
  }
  int step = 1;
  int curr = arrayStart;
  while (curr + step < arrayEnd && array[curr + step] < target) {
    curr += step;
    step = step * 2;
  }

  step = step / 2;
  while (step > 0) {
    if (curr + step < arrayEnd && array[curr + step] < target) {
      curr += step;
    }
    step = step / 2;
  }
  return curr+1;
}
int taco_binarySearchAfter(int *array, int arrayStart, int arrayEnd, int target) {
  if (array[arrayStart] >= target) {
    return arrayStart;
  }
  int lowerBound = arrayStart; // always < target
  int upperBound = arrayEnd; // always >= target
  while (upperBound - lowerBound > 1) {
    int mid = (upperBound + lowerBound) / 2;
    int midValue = array[mid];
    if (midValue < target) {
      lowerBound = mid;
    }
    else if (midValue > target) {
      upperBound = mid;
    }
    else {
      return mid;
    }
  }
  return upperBound;
}
int taco_binarySearchBefore(int *array, int arrayStart, int arrayEnd, int target) {
  if (array[arrayEnd] <= target) {
    return arrayEnd;
  }
  int lowerBound = arrayStart; // always <= target
  int upperBound = arrayEnd; // always > target
  while (upperBound - lowerBound > 1) {
    int mid = (upperBound + lowerBound) / 2;
    int midValue = array[mid];
    if (midValue < target) {
      lowerBound = mid;
    }
    else if (midValue > target) {
      upperBound = mid;
    }
    else {
      return mid;
    }
  }
  return lowerBound;
}
taco_tensor_t* init_taco_tensor_t(int32_t order, int32_t csize,
                                  int32_t* dimensions, int32_t* mode_ordering,
                                  taco_mode_t* mode_types) {
  taco_tensor_t* t = (taco_tensor_t *) malloc(sizeof(taco_tensor_t));
  t->order         = order;
  t->dimensions    = (int32_t *) malloc(order * sizeof(int32_t));
  t->mode_ordering = (int32_t *) malloc(order * sizeof(int32_t));
  t->mode_types    = (taco_mode_t *) malloc(order * sizeof(taco_mode_t));
  t->indices       = (uint8_t ***) malloc(order * sizeof(uint8_t***));
  t->csize         = csize;
  for (int32_t i = 0; i < order; i++) {
    t->dimensions[i]    = dimensions[i];
    t->mode_ordering[i] = mode_ordering[i];
    t->mode_types[i]    = mode_types[i];
    switch (t->mode_types[i]) {
      case taco_mode_dense:
        t->indices[i] = (uint8_t **) malloc(1 * sizeof(uint8_t **));
        break;
      case taco_mode_sparse:
        t->indices[i] = (uint8_t **) malloc(2 * sizeof(uint8_t **));
        break;
    }
  }
  return t;
}
void deinit_taco_tensor_t(taco_tensor_t* t) {
  for (int i = 0; i < t->order; i++) {
    free(t->indices[i]);
  }
  free(t->indices);
  free(t->dimensions);
  free(t->mode_ordering);
  free(t->mode_types);
  free(t);
}
#endif

int t_1_1_compute(taco_tensor_t *P, taco_tensor_t *Pi, taco_tensor_t *Ji) {
  int P1_dimension = (int)(P->dimensions[0]);
  double* restrict P_vals = (double*)(P->vals);
  int Pi1_dimension = (int)(Pi->dimensions[0]);
  double* restrict Pi_vals = (double*)(Pi->vals);
  int Ji1_dimension = (int)(Ji->dimensions[0]);
  int* restrict Ji2_pos = (int*)(Ji->indices[1][0]);
  int* restrict Ji2_crd = (int*)(Ji->indices[1][1]);
  double* restrict Ji_vals = (double*)(Ji->vals);

  #pragma omp parallel for schedule(static)
  for (int32_t pP = 0; pP < P1_dimension; pP++) {
    P_vals[pP] = 0.0;
  }

  for (int32_t a = 0; a < Ji1_dimension; a++) {
    for (int32_t tJi = Ji2_pos[a]; tJi < Ji2_pos[(a + 1)]; tJi++) {
      int32_t t = Ji2_crd[tJi];
      P_vals[t] = P_vals[t] + Pi_vals[a] * Ji_vals[tJi];
    }
  }
  return 0;
}

int t_1_1_assemble(taco_tensor_t *P, taco_tensor_t *Pi, taco_tensor_t *Ji) {
  int P1_dimension = (int)(P->dimensions[0]);
  double* restrict P_vals = (double*)(P->vals);

  P_vals = (double*)malloc(sizeof(double) * P1_dimension);

  P->vals = (uint8_t*)P_vals;
  return 0;
}

int t_1_1_evaluate(taco_tensor_t *P, taco_tensor_t *Pi, taco_tensor_t *Ji) {
  int P1_dimension = (int)(P->dimensions[0]);
  double* restrict P_vals = (double*)(P->vals);
  int Pi1_dimension = (int)(Pi->dimensions[0]);
  double* restrict Pi_vals = (double*)(Pi->vals);
  int Ji1_dimension = (int)(Ji->dimensions[0]);
  int* restrict Ji2_pos = (int*)(Ji->indices[1][0]);
  int* restrict Ji2_crd = (int*)(Ji->indices[1][1]);
  double* restrict Ji_vals = (double*)(Ji->vals);

  int32_t P_capacity = P1_dimension;
  P_vals = (double*)malloc(sizeof(double) * P_capacity);

  #pragma omp parallel for schedule(static)
  for (int32_t pP = 0; pP < P_capacity; pP++) {
    P_vals[pP] = 0.0;
  }

  for (int32_t a = 0; a < Ji1_dimension; a++) {
    for (int32_t tJi = Ji2_pos[a]; tJi < Ji2_pos[(a + 1)]; tJi++) {
      int32_t t = Ji2_crd[tJi];
      P_vals[t] = P_vals[t] + Pi_vals[a] * Ji_vals[tJi];
    }
  }

  P->vals = (uint8_t*)P_vals;
  return 0;
}

/*
 * The `pack` functions convert coordinate and value arrays in COO format,
 * with nonzeros sorted lexicographically by their coordinates, to the
 * specified input format.
 *
 * The `unpack` function converts the specified output format to coordinate
 * and value arrays in COO format.
 *
 * For both, the `_COO_pos` arrays contain two elements, where the first is 0
 * and the second is the number of nonzeros in the tensor.
 */

int t_1_1_pack_Pi(taco_tensor_t *Pi, int* Pi_COO1_pos, int* Pi_COO1_crd, double* Pi_COO_vals) {
  int Pi1_dimension = (int)(Pi->dimensions[0]);
  double* restrict Pi_vals = (double*)(Pi->vals);

  int32_t Pi_capacity = Pi1_dimension;
  Pi_vals = (double*)malloc(sizeof(double) * Pi_capacity);

  #pragma omp parallel for schedule(static)
  for (int32_t pPi = 0; pPi < Pi_capacity; pPi++) {
    Pi_vals[pPi] = 0.0;
  }

  int32_t aPi_COO = Pi_COO1_pos[0];
  int32_t pPi_COO1_end = Pi_COO1_pos[1];

  while (aPi_COO < pPi_COO1_end) {
    int32_t a = Pi_COO1_crd[aPi_COO];
    double Pi_COO_val = Pi_COO_vals[aPi_COO];
    aPi_COO++;
    while (aPi_COO < pPi_COO1_end && Pi_COO1_crd[aPi_COO] == a) {
      Pi_COO_val += Pi_COO_vals[aPi_COO];
      aPi_COO++;
    }
    Pi_vals[a] = Pi_COO_val;
  }

  Pi->vals = (uint8_t*)Pi_vals;
  return 0;
}

int t_1_1_pack_Ji(taco_tensor_t *Ji, int* Ji_COO1_pos, int* Ji_COO1_crd, int* Ji_COO2_crd, double* Ji_COO_vals) {
  int Ji1_dimension = (int)(Ji->dimensions[0]);
  int* restrict Ji2_pos = (int*)(Ji->indices[1][0]);
  int* restrict Ji2_crd = (int*)(Ji->indices[1][1]);
  double* restrict Ji_vals = (double*)(Ji->vals);

  Ji2_pos = (int32_t*)malloc(sizeof(int32_t) * (Ji1_dimension + 1));
  Ji2_pos[0] = 0;
  for (int32_t pJi2 = 1; pJi2 < (Ji1_dimension + 1); pJi2++) {
    Ji2_pos[pJi2] = 0;
  }
  int32_t Ji2_crd_size = 1048576;
  Ji2_crd = (int32_t*)malloc(sizeof(int32_t) * Ji2_crd_size);
  int32_t tJi = 0;
  int32_t Ji_capacity = 1048576;
  Ji_vals = (double*)malloc(sizeof(double) * Ji_capacity);

  int32_t aJi_COO = Ji_COO1_pos[0];
  int32_t pJi_COO1_end = Ji_COO1_pos[1];

  while (aJi_COO < pJi_COO1_end) {
    int32_t a = Ji_COO1_crd[aJi_COO];
    int32_t Ji_COO1_segend = aJi_COO + 1;
    while (Ji_COO1_segend < pJi_COO1_end && Ji_COO1_crd[Ji_COO1_segend] == a) {
      Ji_COO1_segend++;
    }
    int32_t pJi2_begin = tJi;

    int32_t tJi_COO = aJi_COO;

    while (tJi_COO < Ji_COO1_segend) {
      int32_t t = Ji_COO2_crd[tJi_COO];
      double Ji_COO_val = Ji_COO_vals[tJi_COO];
      tJi_COO++;
      while (tJi_COO < Ji_COO1_segend && Ji_COO2_crd[tJi_COO] == t) {
        Ji_COO_val += Ji_COO_vals[tJi_COO];
        tJi_COO++;
      }
      if (Ji_capacity <= tJi) {
        Ji_vals = (double*)realloc(Ji_vals, sizeof(double) * (Ji_capacity * 2));
        Ji_capacity *= 2;
      }
      Ji_vals[tJi] = Ji_COO_val;
      if (Ji2_crd_size <= tJi) {
        Ji2_crd = (int32_t*)realloc(Ji2_crd, sizeof(int32_t) * (Ji2_crd_size * 2));
        Ji2_crd_size *= 2;
      }
      Ji2_crd[tJi] = t;
      tJi++;
    }

    Ji2_pos[a + 1] = tJi - pJi2_begin;
    aJi_COO = Ji_COO1_segend;
  }

  int32_t csJi2 = 0;
  for (int32_t pJi20 = 1; pJi20 < (Ji1_dimension + 1); pJi20++) {
    csJi2 += Ji2_pos[pJi20];
    Ji2_pos[pJi20] = csJi2;
  }

  Ji->indices[1][0] = (uint8_t*)(Ji2_pos);
  Ji->indices[1][1] = (uint8_t*)(Ji2_crd);
  Ji->vals = (uint8_t*)Ji_vals;
  return 0;
}

int t_1_1_unpack(int** P_COO1_pos_ptr, int** P_COO1_crd_ptr, double** P_COO_vals_ptr, taco_tensor_t *P) {
  int* P_COO1_pos;
  int* P_COO1_crd;
  double* P_COO_vals;
  int P1_dimension = (int)(P->dimensions[0]);
  double* restrict P_vals = (double*)(P->vals);

  P_COO1_pos = (int32_t*)malloc(sizeof(int32_t) * 2);
  P_COO1_pos[0] = 0;
  int32_t P_COO1_crd_size = 1048576;
  P_COO1_crd = (int32_t*)malloc(sizeof(int32_t) * P_COO1_crd_size);
  int32_t tP_COO = 0;
  int32_t P_COO_capacity = 1048576;
  P_COO_vals = (double*)malloc(sizeof(double) * P_COO_capacity);


  for (int32_t t = 0; t < P1_dimension; t++) {
    if (P_COO_capacity <= tP_COO) {
      P_COO_vals = (double*)realloc(P_COO_vals, sizeof(double) * (P_COO_capacity * 2));
      P_COO_capacity *= 2;
    }
    P_COO_vals[tP_COO] = P_vals[t];
    if (P_COO1_crd_size <= tP_COO) {
      P_COO1_crd = (int32_t*)realloc(P_COO1_crd, sizeof(int32_t) * (P_COO1_crd_size * 2));
      P_COO1_crd_size *= 2;
    }
    P_COO1_crd[tP_COO] = t;
    tP_COO++;
  }

  P_COO1_pos[1] = tP_COO;

  *P_COO1_pos_ptr = P_COO1_pos;
  *P_COO1_crd_ptr = P_COO1_crd;
  *P_COO_vals_ptr = P_COO_vals;
  return 0;
}
